<script setup lang="ts">
import type { Publication } from "~/utils/types/publication";

const props = defineProps<{
  publication: Omit<Publication, "id">;
}>();

const outlink = computed(() => {
  if (props.publication.doi === "") {
    return undefined;
  } else {
    return `https://doi.org/${props.publication.doi}`;
  }
});
const showFull = ref(false);

const authorSummary = computed(() => {
  const firstAuthor = props.publication.authors[0];
  const numOfAuthors = props.publication.authors.length;
  if (numOfAuthors === 1) {
    return firstAuthor.firstName + " " + firstAuthor.lastName;
  } else if (numOfAuthors === 2) {
    const secondAuthor = props.publication.authors[1];
    return firstAuthor.lastName + " and " + secondAuthor.lastName;
  } else if (numOfAuthors > 2) {
    return firstAuthor.lastName + " et al.";
  }
});

const authorFull = computed(() => {
  return props.publication.authors
    .map(({ firstName, lastName }) => firstName + " " + lastName)
    .join(", ");
});

const attributesToDisplay = computed(() => {
  const shortVersion = [
    {
      header: props.publication.authors.length > 1 ? "Authors" : "Author",
      value: showFull.value ? authorFull.value : authorSummary.value,
    },
    { header: "Journal", value: props.publication.journal },
    { header: "Year", value: props.publication.year },
  ];
  if (showFull.value) {
    return [
      ...shortVersion,
      {
        header: "Abstract",
        value: props.publication.abstract,
      },
    ];
  } else {
    return shortVersion;
  }
});
</script>

<template>
  <div>
    <OutLink :to="outlink">{{
      props.publication.title || "No title yet"
    }}</OutLink>
  </div>
  <AttributeList :attributes="attributesToDisplay" :vertical="showFull" />
  <div class="mb-1" />
  <v-btn
    color="secondary"
    size="x-small"
    variant="flat"
    class="mr-2"
    @click="showFull = !showFull"
  >
    {{ showFull ? "Less" : "More" }}
  </v-btn>
  <v-dialog scrollable max-width="640px">
    <template #activator="{ props: dialogProps }">
      <v-btn
        color="secondary"
        v-bind="dialogProps"
        size="x-small"
        class="mr-2"
        variant="flat"
      >
        Cite
      </v-btn>
    </template>
    <v-card>
      <v-card-title>Cite</v-card-title>
      <v-card-text>{{ props.publication.reference }}</v-card-text>
      <v-card-actions>
        <CopyToClipboard :text="props.publication.reference" />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
